pcl::OrganizedFastMesh< PointInT > Class Template Reference
Module surface

Simple triangulation/surface reconstruction for organized point clouds. More...

`#include <pcl/surface/organized_fast_mesh.h>`

Inheritance diagram for pcl::OrganizedFastMesh< PointInT >:

## Public Types

enum | TriangulationType { TRIANGLE_RIGHT_CUT , TRIANGLE_LEFT_CUT , TRIANGLE_ADAPTIVE_CUT , QUAD_MESH }
using | Ptr = shared_ptr< OrganizedFastMesh< PointInT > >
using | ConstPtr = shared_ptr< const OrganizedFastMesh< PointInT > >
using | PointCloudPtr = typename pcl::PointCloud< PointInT >::Ptr
using | Polygons = std::vector< pcl::Vertices >
Public Types inherited from pcl::MeshConstruction< PointInT >
using | Ptr = shared_ptr< MeshConstruction< PointInT > >
using | ConstPtr = shared_ptr< const MeshConstruction< PointInT > >
Public Types inherited from pcl::PCLSurfaceBase< PointInT >
using | Ptr = shared_ptr< PCLSurfaceBase< PointInT > >
using | ConstPtr = shared_ptr< const PCLSurfaceBase< PointInT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| OrganizedFastMesh ()
| Constructor. More...
| ~OrganizedFastMesh ()
| Destructor. More...
void | setMaxEdgeLength (float a, float b=0.0f, float c=0.0f)
| Set a maximum edge length. More...
void | unsetMaxEdgeLength ()
void | setTrianglePixelSize (int triangle_size)
| Set the edge length (in pixels) used for constructing the fixed mesh. More...
void | setTrianglePixelSizeRows (int triangle_size)
| Set the edge length (in pixels) used for iterating over rows when constructing the fixed mesh. More...
void | setTrianglePixelSizeColumns (int triangle_size)
| Set the edge length (in pixels) used for iterating over columns when constructing the fixed mesh. More...
void | setTriangulationType (TriangulationType type)
| Set the triangulation type (see TriangulationType) More...
void | setViewpoint (const Eigen::Vector3f &viewpoint)
| Set the viewpoint from where the input point cloud has been acquired. More...
const Eigen::Vector3f & | getViewpoint () const
| Get the viewpoint from where the input point cloud has been acquired. More...
void | storeShadowedFaces (bool enable)
| Store shadowed faces or not. More...
void | setAngleTolerance (float angle_tolerance)
| Set the angle tolerance used for checking whether or not an edge is occluded. More...
void | setDistanceTolerance (float distance_tolerance, bool depth_dependent=false)
void | useDepthAsDistance (bool enable)
| Use the points' depths (z-coordinates) instead of measured distances (points' distances to the viewpoint). More...
Public Member Functions inherited from pcl::MeshConstruction< PointInT >
| MeshConstruction ()
| Constructor. More...
| ~MeshConstruction ()
| Destructor. More...
void | reconstruct (pcl::PolygonMesh &output) override
| Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()> More...
virtual void | reconstruct (std::vector< pcl::Vertices > &polygons)
| Base method for mesh construction for all points given in <setInputCloud (), setIndices ()> More...
Public Member Functions inherited from pcl::PCLSurfaceBase< PointInT >
| PCLSurfaceBase ()
| Empty constructor. More...
| ~PCLSurfaceBase ()
| Empty destructor. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide an optional pointer to a search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | reconstructPolygons (std::vector< pcl::Vertices > &polygons)
| Perform the actual polygonal reconstruction. More...
void | performReconstruction (std::vector< pcl::Vertices > &polygons) override
| Create the surface. More...
void | performReconstruction (pcl::PolygonMesh &output) override
| Create the surface. More...
void | addTriangle (int a, int b, int c, int idx, std::vector< pcl::Vertices > &polygons)
| Add a new triangle to the current polygon mesh. More...
void | addQuad (int a, int b, int c, int d, int idx, std::vector< pcl::Vertices > &polygons)
| Add a new quad to the current polygon mesh. More...
void | resetPointData (const int &point_index, pcl::PolygonMesh &mesh, const float &value=0.0f, int field_x_idx=0, int field_y_idx=1, int field_z_idx=2)
| Set (all) coordinates of a particular point to the specified value. More...
bool | isShadowed (const PointInT &point_a, const PointInT &point_b)
| Check if a point is shadowed by another point. More...
bool | isValidTriangle (const int &a, const int &b, const int &c)
| Check if a triangle is valid. More...
bool | isShadowedTriangle (const int &a, const int &b, const int &c)
| Check if a triangle is shadowed. More...
bool | isValidQuad (const int &a, const int &b, const int &c, const int &d)
| Check if a quad is valid. More...
bool | isShadowedQuad (const int &a, const int &b, const int &c, const int &d)
| Check if a triangle is shadowed. More...
void | makeQuadMesh (std::vector< pcl::Vertices > &polygons)
| Create a quad mesh. More...
void | makeRightCutMesh (std::vector< pcl::Vertices > &polygons)
| Create a right cut mesh. More...
void | makeLeftCutMesh (std::vector< pcl::Vertices > &polygons)
| Create a left cut mesh. More...
void | makeAdaptiveCutMesh (std::vector< pcl::Vertices > &polygons)
| Create an adaptive cut mesh. More...
Protected Member Functions inherited from pcl::PCLSurfaceBase< PointInT >
virtual std::string | getClassName () const
| Abstract class get name method. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

float | max_edge_length_a_
| max length of edge, scalar component More...
float | max_edge_length_b_
| max length of edge, scalar component More...
float | max_edge_length_c_
| max length of edge, scalar component More...
bool | max_edge_length_set_
| flag whether or not edges are limited in length More...
bool | max_edge_length_dist_dependent_
| flag whether or not max edge length is distance dependent. More...
int | triangle_pixel_size_rows_
| size of triangle edges (in pixels) for iterating over rows. More...
int | triangle_pixel_size_columns_
| size of triangle edges (in pixels) for iterating over columns More...
TriangulationType | triangulation_type_
| Type of meshing scheme (quads vs. More...
Eigen::Vector3f | viewpoint_
| Viewpoint from which the point cloud has been acquired (in the same coordinate frame as the data). More...
bool | store_shadowed_faces_
| Whether or not shadowed faces are stored, e.g., for exploration. More...
float | cos_angle_tolerance_
| (Cosine of the) angle tolerance used when checking whether or not an edge between two points is shadowed. More...
float | distance_tolerance_
| distance tolerance for filtering out shadowed/occluded edges More...
bool | distance_dependent_
| flag whether or not distance_tolerance_ is distance dependent (multiplied by the squared distance to the point) or not. More...
bool | use_depth_as_distance_
| flag whether or not the points' depths are used instead of measured distances (points' distances to the viewpoint). More...
Protected Attributes inherited from pcl::MeshConstruction< PointInT >
bool | check_tree_
| A flag specifying whether or not the derived reconstruction algorithm needs the search object tree. More...
Protected Attributes inherited from pcl::PCLSurfaceBase< PointInT >
KdTreePtr | tree_
| A pointer to the spatial search object. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT>
class pcl::OrganizedFastMesh< PointInT >

Simple triangulation/surface reconstruction for organized point clouds.

Neighboring points (pixels in image space) are connected to construct a triangular (or quad) mesh.

Note
  If you use this code in any academic work, please cite: D. Holz and S. Behnke. Fast Range Image Segmentation and Smoothing using Approximate Surface Reconstruction and Region Growing. In Proceedings of the 12th International Conference on Intelligent Autonomous Systems (IAS), Jeju Island, Korea, June 26-29 2012. http://purl.org/holz/papers/holz_2012_ias.pdf

Author
  Dirk Holz, Radu B. Rusu

Definition at line 66 of file organized_fast_mesh.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT >

using pcl::OrganizedFastMesh< PointInT >::ConstPtr = shared_ptr<const OrganizedFastMesh<PointInT> >

Definition at line 70 of file organized_fast_mesh.h.

## PointCloudPtr

template<typename PointInT >

using pcl::OrganizedFastMesh< PointInT >::PointCloudPtr = typename pcl::PointCloud<PointInT>::Ptr

Definition at line 75 of file organized_fast_mesh.h.

## Polygons

template<typename PointInT >

using pcl::OrganizedFastMesh< PointInT >::Polygons = std::vector<pcl::Vertices>

Definition at line 77 of file organized_fast_mesh.h.

## Ptr

template<typename PointInT >

using pcl::OrganizedFastMesh< PointInT >::Ptr = shared_ptr<OrganizedFastMesh<PointInT> >

Definition at line 69 of file organized_fast_mesh.h.

## Member Enumeration Documentation

## TriangulationType

template<typename PointInT >

enum pcl::OrganizedFastMesh::TriangulationType

Enumerator
TRIANGLE_RIGHT_CUT |
TRIANGLE_LEFT_CUT |
TRIANGLE_ADAPTIVE_CUT |
QUAD_MESH |

Definition at line 79 of file organized_fast_mesh.h.

## Constructor & Destructor Documentation

## OrganizedFastMesh()

template<typename PointInT >

pcl::OrganizedFastMesh< PointInT >::OrganizedFastMesh | ( |  | ) |

inline

Constructor.

Triangulation type defaults to QUAD_MESH.

Definition at line 88 of file organized_fast_mesh.h.

References pcl::MeshConstruction< PointInT >::check_tree_.

## ~OrganizedFastMesh()

template<typename PointInT >

pcl::OrganizedFastMesh< PointInT >::~OrganizedFastMesh | ( |  | ) |

inline

Destructor.

Definition at line 108 of file organized_fast_mesh.h.

## Member Function Documentation

## addQuad()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::addQuad | ( | int | a,
|  | int | b,
|  | int | c,
|  | int | d,
|  | int | idx,
|  | std::vector< pcl::Vertices > & | polygons
| ) |  |

inline protected

Add a new quad to the current polygon mesh.

Parameters

  [in] | a | index of the first vertex
  [in] | b | index of the second vertex
  [in] | c | index of the third vertex
  [in] | d | index of the fourth vertex
  [in] | idx | the index in the set of polygon vertices (assumes idx is valid in polygons)
  [out] | polygons | the polygon mesh to be updated

Definition at line 322 of file organized_fast_mesh.h.

## addTriangle()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::addTriangle | ( | int | a,
|  | int | b,
|  | int | c,
|  | int | idx,
|  | std::vector< pcl::Vertices > & | polygons
| ) |  |

inline protected

Add a new triangle to the current polygon mesh.

Parameters

  [in] | a | index of the first vertex
  [in] | b | index of the second vertex
  [in] | c | index of the third vertex
  [in] | idx | the index in the set of polygon vertices (assumes idx is valid in polygons)
  [out] | polygons | the polygon mesh to be updated

Definition at line 304 of file organized_fast_mesh.h.

## getViewpoint()

template<typename PointInT >

const Eigen::Vector3f& pcl::OrganizedFastMesh< PointInT >::getViewpoint | ( |  | ) | const

inline

Get the viewpoint from where the input point cloud has been acquired.

Definition at line 185 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::viewpoint_.

## isShadowed()

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::isShadowed | ( | const PointInT & | point_a,
|  | const PointInT & | point_b
| ) |  |

inline protected

Check if a point is shadowed by another point.

Parameters

  [in] | point_a | the first point
  [in] | point_b | the second point

Definition at line 355 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::cos_angle_tolerance_, pcl::OrganizedFastMesh< PointInT >::distance_dependent_, pcl::OrganizedFastMesh< PointInT >::distance_tolerance_, pcl::OrganizedFastMesh< PointInT >::max_edge_length_a_, pcl::OrganizedFastMesh< PointInT >::max_edge_length_b_, pcl::OrganizedFastMesh< PointInT >::max_edge_length_c_, pcl::OrganizedFastMesh< PointInT >::max_edge_length_set_, pcl::OrganizedFastMesh< PointInT >::use_depth_as_distance_, and pcl::OrganizedFastMesh< PointInT >::viewpoint_.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowedQuad(), and pcl::OrganizedFastMesh< PointInT >::isShadowedTriangle().

## isShadowedQuad()

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::isShadowedQuad | ( | const int & | a,
|  | const int & | b,
|  | const int & | c,
|  | const int & | d
| ) |  |

inline protected

Check if a triangle is shadowed.

Parameters

  [in] | a | index of the first vertex
  [in] | b | index of the second vertex
  [in] | c | index of the third vertex
  [in] | d | index of the fourth vertex

Definition at line 454 of file organized_fast_mesh.h.

References pcl::PCLBase< PointInT >::input_, and pcl::OrganizedFastMesh< PointInT >::isShadowed().

## isShadowedTriangle()

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::isShadowedTriangle | ( | const int & | a,
|  | const int & | b,
|  | const int & | c
| ) |  |

inline protected

Check if a triangle is shadowed.

Parameters

  [in] | a | index of the first vertex
  [in] | b | index of the second vertex
  [in] | c | index of the third vertex

Definition at line 423 of file organized_fast_mesh.h.

References pcl::PCLBase< PointInT >::input_, and pcl::OrganizedFastMesh< PointInT >::isShadowed().

## isValidQuad()

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::isValidQuad | ( | const int & | a,
|  | const int & | b,
|  | const int & | c,
|  | const int & | d
| ) |  |

inline protected

Check if a quad is valid.

Parameters

  [in] | a | index of the first vertex
  [in] | b | index of the second vertex
  [in] | c | index of the third vertex
  [in] | d | index of the fourth vertex

Definition at line 438 of file organized_fast_mesh.h.

References pcl::PCLBase< PointInT >::input_, and pcl::isFinite().

## isValidTriangle()

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::isValidTriangle | ( | const int & | a,
|  | const int & | b,
|  | const int & | c
| ) |  |

inline protected

Check if a triangle is valid.

Parameters

  [in] | a | index of the first vertex
  [in] | b | index of the second vertex
  [in] | c | index of the third vertex

Definition at line 409 of file organized_fast_mesh.h.

References pcl::PCLBase< PointInT >::input_, and pcl::isFinite().

## makeAdaptiveCutMesh()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::makeAdaptiveCutMesh | ( | std::vector< pcl::Vertices > & | polygons | ) |

protected

Create an adaptive cut mesh.

Parameters

  [out] | polygons | the resultant mesh

Definition at line 210 of file organized_fast_mesh.hpp.

## makeLeftCutMesh()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::makeLeftCutMesh | ( | std::vector< pcl::Vertices > & | polygons | ) |

protected

Create a left cut mesh.

Parameters

  [out] | polygons | the resultant mesh

Definition at line 169 of file organized_fast_mesh.hpp.

## makeQuadMesh()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::makeQuadMesh | ( | std::vector< pcl::Vertices > & | polygons | ) |

protected

Create a quad mesh.

Parameters

  [out] | polygons | the resultant mesh

Definition at line 91 of file organized_fast_mesh.hpp.

## makeRightCutMesh()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::makeRightCutMesh | ( | std::vector< pcl::Vertices > & | polygons | ) |

protected

Create a right cut mesh.

Parameters

  [out] | polygons | the resultant mesh

Definition at line 128 of file organized_fast_mesh.hpp.

## performReconstruction() [1/2]

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::performReconstruction | ( | pcl::PolygonMesh & | output | ) |

override protected virtual

Create the surface.

Simply uses image indices to create an initial polygonal mesh for organized point clouds. indices_ are ignored!

Parameters

  [out] | output | the resultant polygonal mesh

Implements pcl::MeshConstruction< PointInT >.

Definition at line 49 of file organized_fast_mesh.hpp.

References pcl::PolygonMesh::cloud, pcl::getFieldIndex(), pcl::isFinite(), and pcl::PolygonMesh::polygons.

## performReconstruction() [2/2]

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::performReconstruction | ( | std::vector< pcl::Vertices > & | polygons | ) |

override protected virtual

Create the surface.

Parameters

  [out] | polygons | the resultant polygons, as a set of vertices. The Vertices structure contains an array of point indices.

Implements pcl::MeshConstruction< PointInT >.

Definition at line 70 of file organized_fast_mesh.hpp.

## reconstructPolygons()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::reconstructPolygons | ( | std::vector< pcl::Vertices > & | polygons | ) |

protected

Perform the actual polygonal reconstruction.

Parameters

  [out] | polygons | the resultant polygons

Definition at line 77 of file organized_fast_mesh.hpp.

## resetPointData()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::resetPointData | ( | const int & | point_index,
|  | pcl::PolygonMesh & | mesh,
|  | const float & | value = `0.0f`,
|  | int | field_x_idx = `0`,
|  | int | field_y_idx = `1`,
|  | int | field_z_idx = `2`
| ) |  |

inline protected

Set (all) coordinates of a particular point to the specified value.

Parameters

  [in] | point_index | index of point
  [out] | mesh | to modify
  [in] | value | value to use when re-setting
  [in] | field_x_idx | the X coordinate of the point
  [in] | field_y_idx | the Y coordinate of the point
  [in] | field_z_idx | the Z coordinate of the point

Definition at line 341 of file organized_fast_mesh.h.

References pcl::PolygonMesh::cloud, pcl::PCLPointCloud2::data, pcl::PCLPointCloud2::fields, and pcl::PCLPointCloud2::point_step.

## setAngleTolerance()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setAngleTolerance | ( | float | angle_tolerance | ) |

inline

Set the angle tolerance used for checking whether or not an edge is occluded.

Standard values are 5deg to 15deg (input in rad!). Set a value smaller than zero to disable the check for shadowed edges.

Parameters

  [in] | angle_tolerance | Angle tolerance (in rad). Set a value <0 to disable.

Definition at line 205 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::cos_angle_tolerance_.

## setDistanceTolerance()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setDistanceTolerance | ( | float | distance_tolerance,
|  | bool | depth_dependent = `false`
| ) |  |

inline

Definition at line 214 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::distance_dependent_, and pcl::OrganizedFastMesh< PointInT >::distance_tolerance_.

## setMaxEdgeLength()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setMaxEdgeLength | ( | float | a,
|  | float | b = `0.0f`,
|  | float | c = `0.0f`
| ) |  |

inline

Set a maximum edge length.

Using not only the scalar a, but also b and c, allows for using a distance threshold in the form of: threshold(x) = c*x*x + b*x + a

Parameters

  [in] | a | scalar coefficient of the (distance-dependent polynom) threshold
  [in] | b | linear coefficient of the (distance-dependent polynom) threshold
  [in] | c | quadratic coefficient of the (distance-dependent polynom) threshold

Definition at line 118 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::max_edge_length_a_, pcl::OrganizedFastMesh< PointInT >::max_edge_length_b_, pcl::OrganizedFastMesh< PointInT >::max_edge_length_c_, and pcl::OrganizedFastMesh< PointInT >::max_edge_length_set_.

## setTrianglePixelSize()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSize | ( | int | triangle_size | ) |

inline

Set the edge length (in pixels) used for constructing the fixed mesh.

Parameters

  [in] | triangle_size | edge length in pixels (Default: 1 = neighboring pixels are connected)

Definition at line 140 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSizeColumns(), and pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSizeRows().

## setTrianglePixelSizeColumns()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSizeColumns | ( | int | triangle_size | ) |

inline

Set the edge length (in pixels) used for iterating over columns when constructing the fixed mesh.

Parameters

  [in] | triangle_size | edge length in pixels (Default: 1 = neighboring pixels are connected)

Definition at line 161 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::triangle_pixel_size_columns_.

Referenced by pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSize().

## setTrianglePixelSizeRows()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSizeRows | ( | int | triangle_size | ) |

inline

Set the edge length (in pixels) used for iterating over rows when constructing the fixed mesh.

Parameters

  [in] | triangle_size | edge length in pixels (Default: 1 = neighboring pixels are connected)

Definition at line 151 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::triangle_pixel_size_rows_.

Referenced by pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSize().

## setTriangulationType()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setTriangulationType | ( | TriangulationType | type | ) |

inline

Set the triangulation type (see TriangulationType)

Parameters

  [in] | type | quad mesh, triangle mesh with fixed left, right cut, or adaptive cut (splits a quad w.r.t. the depth (z) of the points)

Definition at line 171 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::triangulation_type_.

## setViewpoint()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::setViewpoint | ( | const Eigen::Vector3f & | viewpoint | ) |

inline

Set the viewpoint from where the input point cloud has been acquired.

Parameters

  [in] | viewpoint | Vector containing the viewpoint coordinates (in the coordinate system of the data)

Definition at line 179 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::viewpoint_.

## storeShadowedFaces()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::storeShadowedFaces | ( | bool | enable | ) |

inline

Store shadowed faces or not.

Parameters

  [in] | enable | set to true to store shadowed faces

Definition at line 194 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::store_shadowed_faces_.

## unsetMaxEdgeLength()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::unsetMaxEdgeLength | ( |  | ) |

inline

Definition at line 130 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::max_edge_length_set_.

## useDepthAsDistance()

template<typename PointInT >

void pcl::OrganizedFastMesh< PointInT >::useDepthAsDistance | ( | bool | enable | ) |

inline

Use the points' depths (z-coordinates) instead of measured distances (points' distances to the viewpoint).

Parameters

  [in] | enable | Set to true skips comptations and further speeds up computation by using depth instead of computing distance. false to disable.

Definition at line 227 of file organized_fast_mesh.h.

References pcl::OrganizedFastMesh< PointInT >::use_depth_as_distance_.

## Member Data Documentation

## cos_angle_tolerance_

template<typename PointInT >

float pcl::OrganizedFastMesh< PointInT >::cos_angle_tolerance_

protected

(Cosine of the) angle tolerance used when checking whether or not an edge between two points is shadowed.

Definition at line 261 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setAngleTolerance().

## distance_dependent_

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::distance_dependent_

protected

flag whether or not distance_tolerance_ is distance dependent (multiplied by the squared distance to the point) or not.

Definition at line 267 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setDistanceTolerance().

## distance_tolerance_

template<typename PointInT >

float pcl::OrganizedFastMesh< PointInT >::distance_tolerance_

protected

distance tolerance for filtering out shadowed/occluded edges

Definition at line 264 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setDistanceTolerance().

## max_edge_length_a_

template<typename PointInT >

float pcl::OrganizedFastMesh< PointInT >::max_edge_length_a_

protected

max length of edge, scalar component

Definition at line 234 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setMaxEdgeLength().

## max_edge_length_b_

template<typename PointInT >

float pcl::OrganizedFastMesh< PointInT >::max_edge_length_b_

protected

max length of edge, scalar component

Definition at line 236 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setMaxEdgeLength().

## max_edge_length_c_

template<typename PointInT >

float pcl::OrganizedFastMesh< PointInT >::max_edge_length_c_

protected

max length of edge, scalar component

Definition at line 238 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setMaxEdgeLength().

## max_edge_length_dist_dependent_

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::max_edge_length_dist_dependent_

protected

flag whether or not max edge length is distance dependent.

Definition at line 243 of file organized_fast_mesh.h.

## max_edge_length_set_

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::max_edge_length_set_

protected

flag whether or not edges are limited in length

Definition at line 240 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), pcl::OrganizedFastMesh< PointInT >::setMaxEdgeLength(), and pcl::OrganizedFastMesh< PointInT >::unsetMaxEdgeLength().

## store_shadowed_faces_

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::store_shadowed_faces_

protected

Whether or not shadowed faces are stored, e.g., for exploration.

Definition at line 258 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::storeShadowedFaces().

## triangle_pixel_size_columns_

template<typename PointInT >

int pcl::OrganizedFastMesh< PointInT >::triangle_pixel_size_columns_

protected

size of triangle edges (in pixels) for iterating over columns

Definition at line 249 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSizeColumns().

## triangle_pixel_size_rows_

template<typename PointInT >

int pcl::OrganizedFastMesh< PointInT >::triangle_pixel_size_rows_

protected

size of triangle edges (in pixels) for iterating over rows.

Definition at line 246 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::setTrianglePixelSizeRows().

## triangulation_type_

template<typename PointInT >

TriangulationType pcl::OrganizedFastMesh< PointInT >::triangulation_type_

protected

Type of meshing scheme (quads vs.

triangles, left cut vs. right cut ...

Definition at line 252 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::setTriangulationType().

## use_depth_as_distance_

template<typename PointInT >

bool pcl::OrganizedFastMesh< PointInT >::use_depth_as_distance_

protected

flag whether or not the points' depths are used instead of measured distances (points' distances to the viewpoint).

This flag may be set using useDepthAsDistance(true) for (RGB-)Depth cameras to skip computations and gain additional speed up.

Definition at line 271 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::useDepthAsDistance().

## viewpoint_

template<typename PointInT >

Eigen::Vector3f pcl::OrganizedFastMesh< PointInT >::viewpoint_

protected

Viewpoint from which the point cloud has been acquired (in the same coordinate frame as the data).

Definition at line 255 of file organized_fast_mesh.h.

Referenced by pcl::OrganizedFastMesh< PointInT >::getViewpoint(), pcl::OrganizedFastMesh< PointInT >::isShadowed(), and pcl::OrganizedFastMesh< PointInT >::setViewpoint().

The documentation for this class was generated from the following files:

- pcl/surface/organized_fast_mesh.h
- pcl/surface/impl/organized_fast_mesh.hpp